OpenShot Audio Library | OpenShotAudio: juce::MemoryMappedFile Class Reference

OpenShot Audio Library | OpenShotAudio 0.4.0 |

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
juce::MemoryMappedFile Class Reference

`#include <juce_MemoryMappedFile.h>`

## Public Types
enum | AccessMode { readOnly , readWrite }

## Public Member Functions
| MemoryMappedFile (const File &file, AccessMode mode, bool exclusive=false)
| MemoryMappedFile (const File &file, const Range< int64 > &fileRange, AccessMode mode, bool exclusive=false)
| ~MemoryMappedFile ()
void * | getData () const noexcept
size_t | getSize () const noexcept
Range< int64 > | getRange () const noexcept

## Detailed Description

Maps a file into virtual memory for easy reading and/or writing.

Definition at line 32 of file juce_MemoryMappedFile.h.

## Member Enumeration Documentation

## ◆ AccessMode

enum juce::MemoryMappedFile::AccessMode

The read/write flags used when opening a memory mapped file.

Enumerator
readOnly | Indicates that the memory can only be read.
readWrite | Indicates that the memory can be read and written to - changes that are made will be flushed back to disk at the whim of the OS.

Definition at line 36 of file juce_MemoryMappedFile.h.

## Constructor & Destructor Documentation

## ◆ MemoryMappedFile() [1/2]

juce::MemoryMappedFile::MemoryMappedFile | ( | const File & | file,
|  | MemoryMappedFile::AccessMode | mode,
|  | bool | exclusive = false )

Opens a file and maps it to an area of virtual memory.

The file should already exist, and should already be the size that you want to work with when you call this. If the file is resized after being opened, the behaviour is undefined.

If the file exists and the operation succeeds, the getData() and getSize() methods will return the location and size of the data that can be read or written. Note that the entire file is not read into memory immediately - the OS simply creates a virtual mapping, which will lazily pull the data into memory when blocks are accessed.

If the file can't be opened for some reason, the getData() method will return a null pointer.

If exclusive is false then other apps can also open the same memory mapped file and use this mapping as an effective way of communicating. If exclusive is true then the mapped file will be opened exclusively - preventing other apps to access the file which may improve the performance of accessing the file.

Definition at line 1031 of file juce_File.cpp.

## ◆ MemoryMappedFile() [2/2]

juce::MemoryMappedFile::MemoryMappedFile | ( | const File & | file,
|  | const Range< int64 > & | fileRange,
|  | AccessMode | mode,
|  | bool | exclusive = false )

Opens a section of a file and maps it to an area of virtual memory.

The file should already exist, and should already be the size that you want to work with when you call this. If the file is resized after being opened, the behaviour is undefined.

If the file exists and the operation succeeds, the getData() and getSize() methods will return the location and size of the data that can be read or written. Note that the entire file is not read into memory immediately - the OS simply creates a virtual mapping, which will lazily pull the data into memory when blocks are accessed.

If the file can't be opened for some reason, the getData() method will return a null pointer.

NOTE: The start of the actual range used may be rounded-down to a multiple of the OS's page-size, so do not assume that the mapped memory will begin at exactly the position you requested - always use getRange() to check the actual range that is being used.

Definition at line 1037 of file juce_File.cpp.

## ◆ ~MemoryMappedFile()

juce::MemoryMappedFile::~MemoryMappedFile | ( |  | ) |

Destructor.

## Member Function Documentation

## ◆ getData()

void * juce::MemoryMappedFile::getData | ( |  | ) | const
| inlinenoexcept

Returns the address at which this file has been mapped, or a null pointer if the file couldn't be successfully mapped.

Definition at line 89 of file juce_MemoryMappedFile.h.

## ◆ getRange()

Range< int64 > juce::MemoryMappedFile::getRange | ( |  | ) | const
| inlinenoexcept

Returns the section of the file at which the mapped memory represents.

Definition at line 97 of file juce_MemoryMappedFile.h.

## ◆ getSize()

size_t juce::MemoryMappedFile::getSize | ( |  | ) | const
| inlinenoexcept

Returns the number of bytes of data that are available for reading or writing. This will normally be the size of the file.

Definition at line 94 of file juce_MemoryMappedFile.h.

Referenced by MemoryMappedFile(), and MemoryMappedFile().

The documentation for this class was generated from the following files:

- juce_MemoryMappedFile.h
- juce_File.cpp